package com.jiuqi.script;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ScriptManager {
   private static List factoryList = new ArrayList();
   private static Map factoryMap = new HashMap();

   static {
      try {
         Class.forName("com.jiuqi.script.rhino.RhinoScript");
      } catch (ClassNotFoundException var0) {
      }

   }

   private ScriptManager() {
   }

   public static Script getScript(String name) throws ScriptException {
      ScriptFactory factory = (ScriptFactory)factoryMap.get(name);
      if (factory == null) {
         throw new ScriptException("未注册名为" + name + "的脚本引擎");
      } else {
         return factory.createScript();
      }
   }

   public static void registerScriptFactory(ScriptFactory scriptFactory) {
      factoryList.add(scriptFactory);
      String[] names = scriptFactory.getNames();

      for(int i = 0; i < names.length; ++i) {
         factoryMap.put(names[i], scriptFactory);
      }

   }

   public static ScriptFactory[] getScriptFactories() {
      return (ScriptFactory[])factoryList.toArray(new ScriptFactory[0]);
   }
}
